# file      : build/cxx/gnu/cxx-o.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; see accompanying LICENSE file

$(call include-once,$(bld_root)/c/cpp-options.make,$(out_root))
$(call include,$(bld_root)/cxx/gnu/configuration.make)

$(out_root)/%.o: cxx := $(cxx_gnu)
$(out_root)/%.o: cxx_options := $(cxx_gnu_optimization_options) $(cxx_gnu_debugging_options)

#@@ wrong prefix
#
define expand-cpp-options-impl
$(if $1,$(shell sed -e 's%include: \(.*\)%\1%;t;d' $1))
endef

define expand-cpp-options
$(call expand-cpp-options-impl,$(filter %.cpp-options,$1))
endef


$(out_root)/%.o: $(out_root)/%$(cxx_s_suffix) | $$(dir $$@).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-options,$^) \
$(cxx_options) $(cxx_pic_options) -o $@ -c $<)


ifneq ($(out_root),$(src_root))

$(out_root)/%.o: $(src_root)/%$(cxx_s_suffix) | $$(dir $$@).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-options,$^) \
$(cxx_options) $(cxx_pic_options) -o $@ -c $<)

endif


.PHONY: $(out_root)/%.o.clean

$(out_root)/%.o.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@))
