# file      : build/import.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; see accompanying LICENSE file

%reserved% += import export

define set-value
$(eval $$1 := $$2)
endef

define exported-names
$(foreach i,1 2 3 4 5 6 7,$(if $(value $i),$(lastword $(value $i))))
endef

define import-names
$(foreach i,1 2 3 4 5 6 7,$(if $(lastword $(value $i)),\
$(call set-value,$(lastword $(value $i)),$(value $(firstword $(value $i))))))
endef

#@@ %reimported% is kind of ugly but I don't know a better way yet.
#
define import-body
$(call frame-enter,$(call exported-names,$4,$5,$6,$7,$8,$9,$(10)))

$(eval %reimported% := $(%imported%))
$(eval %imported% := true)

$(call include-once,$1)

$(eval %imported% := $2)
$(eval %reimported% := $3)

$(call import-names,$4,$5,$6,$7,$8,$9,$(10))

$(call frame-leave)
endef

define import
$(eval $(call import-body,$(scf_root)/import/$(strip $1)/stub.make,$(%imported%),$(%reimported%),\
$2,$3,$4,$5,$6,$7,$8))
endef

#
# export
#

define export-names
$(foreach i,1 2 3 4 5 6 7,$(if $(value $i),\
$(call set-value,$(firstword $(value $i)),$(word 2,$(value $i)))))
endef


define export
$(call export-names,$1,$2,$3,$4,$5,$6,$7)
endef
